#relate Lascuarre bridge and tube


source("f_read_loggerdata.R")

stage_file_dir="./hdata/" #directory containing stage records

logger_data_bridge=read_loggerdata(gauge="Lascuarre", datum="bridge", device="TT", stage_file_dir=stage_file_dir) #try to read logger data
logger_data_tube  =read_loggerdata(gauge="Lascuarre", datum="tube",   device="TT", stage_file_dir=stage_file_dir) #try to read logger data

mindate=max(min(logger_data_bridge$date), min(logger_data_tube$date))
maxdate=min(max(logger_data_bridge$date), max(logger_data_tube$date))

logger_data_bridge = logger_data_bridge[logger_data_bridge$date >= mindate & logger_data_bridge$date <= maxdate,]
logger_data_tube   = logger_data_tube  [logger_data_tube$date   >= mindate & logger_data_tube$date   <= maxdate,]



  timestep_representation=0.5   #how are records assigned to output resolution. Example for 1 h resolution  
  #0: all data between 11:00 and 12:00 is assigned to record with timestamp 12:00
  #0.5: all data between 11:30 and 12:30 is assigned to record with timestamp 12:00
  #1: all data between 12:00 and 13:00 is assigned to record with timestamp 12:00                                
  time_step=as.difftime(5, units="mins")
  aggr_fun=mean

  somedate=ISOdate(2000,1,1)  #aux for date operations
  origin=somedate-as.numeric(somedate)
  
  
  
        time_interval_minutes=as.numeric(time_step)
        
        start_date_vec=mindate
        end_date_vec  =maxdate
        
                
        time_line = seq(from=start_date_vec-2*time_step, to=end_date_vec+2*time_step, by=time_step, tz = "GMT")  #generate time sequence
        time_line = floor(as.numeric(time_line)/60/time_interval_minutes) * time_interval_minutes * 60
        time_line = as.POSIXct(time_line, origin=origin,tz="GMT")
        
      both = data.frame(date=time_line)
      for (i in 1:2)
      {    
        if (i==1) logger_data=logger_data_bridge else
          logger_data=logger_data_tube
        
        resampled_data=rep(0*NA,length(time_line))     
        
#         SampleTimeStart <- logger_data$date - time_step
#         SampleTimeEnd   <- logger_data$date
        sample_values=logger_data$stage            #speed up access
        
        sample_values[which(is.nan(sample_values))]=NA   #replace NaN with NA
        
        intermittent=FALSE       #regular sampling interval
#        representative_time = SampleTimeStart+as.numeric(difftime(SampleTimeEnd,SampleTimeStart,units="secs"))/2 #clumsy, but the only way that I could think of
 
        time_rounded = floor(as.numeric(logger_data$date)/60/time_interval_minutes + timestep_representation) * time_interval_minutes * 60
        time_rounded = as.POSIXct(time_rounded, origin=origin)
        
        aggr=aggregate(sample_values, by=list(date=time_rounded), FUN=mean)
        
        #resamp=merge(data.frame(date=time_line), aggr, by="date", all.x=TRUE)
        both=merge(both, aggr, by="date", all.x=TRUE)
        names(both)[1+i]=paste0("stage",i)
      }
    
    fromt= strptime("21.2.2013 10:56",format="%d.%m.%Y %H:%M")
    tot  = strptime("22.5.2013 10:55",format="%d.%m.%Y %H:%M")

    dplot = both[!(both$date>=fromt & both$date <=tot),]
    
    windows()
    plot(dplot$stage1, dplot$stage2, pch=".", xlab="bridge", ylab="tube")
    abline(a=0, b=1)

    identify(dplot[,2], dplot[,3], labels = dplot[,1])

  mod = lm(stage2 ~ stage1, data=dplot)

